/*Que se cargue esto sólo si no ha sido cargado ya*/
#ifndef DIN_PILES_LIB
#define DIN_PILES_LIB

/*Tipos de datos para pilas genéricas*/
#define STDTYPE void *
#define STDPILE dinpile
#define STDNODE dinnode
#define STDFAKENODE dinnode_

typedef struct STDFAKENODE {
    STDTYPE element;
    struct STDFAKENODE *prev;
} STDNODE;

typedef struct {
    STDNODE *begin;
    STDNODE *act;
    int elements;
} STDPILE;

int dinpile_create (STDPILE **pile);
int dinpile_push (STDPILE *pile, STDTYPE element);
int dinpile_pop (STDPILE *pile);
int dinpile_cime (STDPILE *pile, STDTYPE *out);
int dinpile_empty (STDPILE *pile);
int dinpile_setmaxsize (int maxelem);
int dinpile_getmaxsize (void);
int dinpile_resize (STDPILE *pile);

/*"Alias" a las funciones si no hay cargada otra librería de pilas*/
#ifndef PILES_LIB
    #define pile_create(a) dinpile_create((a))
    #define pile_push(a,b) dinpile_push((a),(b))
    #define pile_pop(a) dinpile_pop((a))
    #define pile_cime(a,b) dinpile_cime((a),(b))
    #define pile_empty(a) dinpile_empty((a))
    /*Esta macro está sólo por compatibilidad con las pilas vectoriales*/
    #define pile_setmaxsize(a) dinpile_setmaxsize ((a));
    #define pile_getmaxsize() dinpile_getmaxsize ();
    #define pile_resize(a) dinpile_resize ((a));
#endif

#undef STDTYPE
#undef STDPILE
#undef STDNODE
#undef STDFAKENODE


#define PILES_LIB

#endif
