/*Hacer que se cargue si no se ha cargado ya*/
#ifndef VECT_PILES_LIB

#define VECT_PILES_LIB

#ifndef MAXELEMENTS
    #define MAXELEMENTS 256
#endif


/*Tipos de datos para pilas genéricas*/
#define STDTYPE void *
#define STDPILE vectpile

typedef struct {
    STDTYPE *act;
    int elements;
    int maxelements;
    STDTYPE *all;
} STDPILE;

int vectpile_create (STDPILE **pile);
int vectpile_push (STDPILE *pile, STDTYPE element);
int vectpile_pop (STDPILE *pile);
int vectpile_cime (STDPILE *pile, STDTYPE *out);
int vectpile_empty (STDPILE *pile);
int vectpile_setmaxsize (int maxelem);
int vectpile_getmaxsize (void);
int vectpile_resize (STDPILE *pile);

/*"Alias" a las funciones si no hay cargada otra librería de pilas*/
#ifndef PILES_LIB
    #define pile_create(a) vectpile_create((a))
    #define pile_push(a,b) vectpile_push((a),(b))
    #define pile_pop(a) vectpile_pop((a))
    #define pile_cime(a,b) vectpile_cime((a),(b))
    #define pile_empty(a) vectpile_empty((a))
    #define pile_setmaxsize(a) vectpile_setmaxsize ((a));
    #define pile_getmaxsize() vectpile_getmaxsize ();
    #define pile_resize(a) vectpile_resize ((a));
#endif

#undef STDTYPE
#undef STDPILE
#undef STDPILEMAXELEMENTS

#define PILES_LIB

#endif
